unit Builder;

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Graphics,
    Controls,
    Forms,
    Dialogs,
    StdCtrls,
    SparkleUnit,
    XPMan,
    ComCtrls,
    ExtCtrls,
    ShellAPI;

type
  TSparkleTest = class(TForm)
    btnBuild: TButton;
    btnCancel: TButton;
    GroupBox3: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    Sparkle1: TSparkle;
    GroupBox1: TGroupBox;
    lblReadMe: TLabel;
    Label6: TLabel;
    lblAbout: TLabel;
    Label5: TLabel;
    lblMovie: TLabel;
    Label4: TLabel;
    edtReadMe: TEdit;
    btnReadMe: TButton;
    edtAbout: TEdit;
    btnAbout: TButton;
    edtMovie: TEdit;
    btnMovie: TButton;
    GroupBox4: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    edtScreenSaver: TEdit;
    btnScreenSaver: TButton;
    GroupBox2: TGroupBox;
    lblUnlockCode: TLabel;
    edtUnlockCode: TEdit;
    btnUnlockCode: TButton;
    xpmXPManifest: TXPManifest;
    odlReadMe: TOpenDialog;
    odlAbout: TOpenDialog;
    odlMovie: TOpenDialog;
    odlScreenSaver: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure btnReadMeClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnMovieClick(Sender: TObject);
    procedure btnScreenSaverClick(Sender: TObject);
    procedure btnUnlockCodeClick(Sender: TObject);
    procedure edtModified(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure btnBuildClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
         procedure SelectFile(Edit : TEdit; OpenDialog : TOpenDialog);
  end;

var
  SparkleTest: TSparkleTest;

implementation

{$R *.dfm}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TSparkleTest.SelectFile(Edit : TEdit; OpenDialog : TOpenDialog);
begin
     with OpenDialog do
          begin
               FileName := Edit.Text;
               if Execute then
                  begin
                       Edit.Text := FileName;
                  end;
          end;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TSparkleTest.FormCreate(Sender: TObject);
var
   S : String;
begin
     // ".." directory path
     S := ExtractFilePath(ExcludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName)));
     edtReadMe.Text      := S + 'ReadMe.rtf';
     edtAbout.Text       := S + 'About.rtf';
     edtMovie.Text       := S + 'Movie.swf';
     edtScreenSaver.Text := S + 'ScreenSaver.exe';
end;
procedure TSparkleTest.btnReadMeClick(Sender: TObject);
begin
     SelectFile(edtReadMe, odlReadMe);
end;

procedure TSparkleTest.btnAboutClick(Sender: TObject);
begin
     SelectFile(edtAbout, odlAbout);
end;

procedure TSparkleTest.btnMovieClick(Sender: TObject);
begin
     SelectFile(edtMovie, odlMovie);
end;

procedure TSparkleTest.btnScreenSaverClick(Sender: TObject);
begin
     SelectFile(edtScreenSaver, odlScreenSaver);
end;

procedure TSparkleTest.btnUnlockCodeClick(Sender: TObject);
begin
     ShellExecute(Handle, 'open', PChar( (Sender as TControl).Hint ), nil, nil, SW_SHOWNORMAL);
end;

procedure TSparkleTest.edtModified(Sender: TObject);
begin
     edtReadMe.OnChange      := nil; // edtModified;
     edtAbout.OnChange       := nil; // edtModified;
     edtMovie.OnChange       := nil; // edtModified;
     edtScreenSaver.OnChange := nil; // edtModified;
     edtUnlockCode.OnChange  := nil; // edtModified;
     try
        with Sparkle1 do
             begin
                  ReadMe      := edtReadMe.Text;
                  About       := edtAbout.Text;
                  Movie       := edtMovie.Text;
                  ScreenSaver := edtScreenSaver.Text;
                  UnlockCode  := edtUnlockCode.Text;
             end;
     finally
            edtReadMe.OnChange      := edtModified;
            edtAbout.OnChange       := edtModified;
            edtMovie.OnChange       := edtModified;
            edtScreenSaver.OnChange := edtModified;
            edtUnlockCode.OnChange  := edtModified;
     end;
end;

procedure TSparkleTest.Button2Click(Sender: TObject);
begin
     Sparkle1.Flash.Play;
end;

procedure TSparkleTest.Button3Click(Sender: TObject);
begin
     Sparkle1.Flash.Stop;
end;

procedure TSparkleTest.btnBuildClick(Sender: TObject);
begin
     if Sparkle1.Build then
        begin
             WinExec(PChar(edtScreenSaver.Text), SW_SHOW);
        end;
end;

procedure TSparkleTest.btnCancelClick(Sender: TObject);
begin
     Close;
end;

end.
